/*
  CPP_CONTEST=2013
  CPP_PROBLEM=B
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 1 mercurio 1
 
  TODO: DIVIDIR EN CUADRADOS
*/

/* RECORD
Daniel Ruiz, Constantino Gómez
students of the Barcelona Supercomputing Centre
In the warm-up for the IV Spanish Parallel Programming Contest
time 3333 msec
speed-up 8.85
*/ 

/*Checkerboard distribution of the work to the processes is used.
Maybe higher speed-up could be obtained by combining MPI+OpenMP,
with two processes and six threads inside each process*/

#include <stdlib.h>
#include <omp.h>
#include <mpi.h>
#include <stdio.h>
#define NUM_CPU 12
#define DIV 2
 
inline void accumulatelocal(int *a,int N,int v,int r1,int c1,int r2,int c2, int rstart, int rend, int CHUNK_SIZE)
{
  int i, j, k, firstrow, lastrow;
  int *pos;
  int step = CHUNK_SIZE*NUM_CPU;
  
  for(k = rstart; k <= N-1; k = k + step)
  {
    firstrow = r1 - ((r1 - k) & -(r1 < k)); 
    lastrow = (k+CHUNK_SIZE-1) + ((r2 - (k+CHUNK_SIZE-1)) & -(r2 < (k+CHUNK_SIZE-1)));

    for(i=firstrow; i <= lastrow; i++)
    {
      pos=&a[i*N];
     	 for(j=c1;j<=c2;j++)
      	{
       	 pos[j]+=v;
      	}
    	}
    }
}
    
void  sec(int N,int M,int *a,int *value,int *r1,int *c1,int *r2,int *c2, int nodo, int np)
{
	int *a2;
	MPI_Request req[7];

	if(nodo == 0) {
		MPI_Isend(&N, 1, MPI_INT, 1, 0, MPI_COMM_WORLD, &req[0]);
		MPI_Wait(&req[0], MPI_STATUS_IGNORE);

		MPI_Isend(&M, 1, MPI_INT, 1, 1, MPI_COMM_WORLD, &req[1]);
		MPI_Wait(&req[1], MPI_STATUS_IGNORE);

		MPI_Isend(value, M, MPI_INT, 1, 2, MPI_COMM_WORLD, &req[2]);
		MPI_Isend(r1, M, MPI_INT, 1, 3, MPI_COMM_WORLD, &req[3]);
		MPI_Isend(c1, M, MPI_INT, 1, 4, MPI_COMM_WORLD, &req[4]);
		MPI_Isend(r2, M, MPI_INT, 1, 5, MPI_COMM_WORLD, &req[5]);
		MPI_Isend(c2, M, MPI_INT, 1, 6, MPI_COMM_WORLD, &req[6]);

		a2 = (int *) calloc(sizeof(int),N*N);

		MPI_Waitall(5, &req[2], MPI_STATUSES_IGNORE);

	} else if (nodo == 1) {
		MPI_Irecv(&N, 1, MPI_INT, 0, 0, MPI_COMM_WORLD, &req[0]);
		MPI_Wait(&req[0], MPI_STATUS_IGNORE);

		MPI_Irecv(&M, 1, MPI_INT, 0, 1, MPI_COMM_WORLD, &req[1]);
		MPI_Wait(&req[1], MPI_STATUS_IGNORE);

		a = (int *) calloc(sizeof(int),N*N);
		a2 = (int *) calloc(sizeof(int),N*N);

		value = (int *) malloc(sizeof(int)*M);
		r1=(int *) malloc(sizeof(int)*M);
		c1=(int *) malloc(sizeof(int)*M);
		r2=(int *) malloc(sizeof(int)*M);
		c2=(int *) malloc(sizeof(int)*M);

		MPI_Irecv(value, M, MPI_INT, 0, 2, MPI_COMM_WORLD, &req[2]);
		MPI_Irecv(r1, M, MPI_INT, 0, 3, MPI_COMM_WORLD, &req[3]);
		MPI_Irecv(c1, M, MPI_INT, 0, 4, MPI_COMM_WORLD, &req[4]);
		MPI_Irecv(r2, M, MPI_INT, 0, 5, MPI_COMM_WORLD, &req[5]);
		MPI_Irecv(c2, M, MPI_INT, 0, 6, MPI_COMM_WORLD, &req[6]);
		
		MPI_Waitall(5, &req[2], MPI_STATUSES_IGNORE);

	}
	//MPI_Barrier(MPI_COMM_WORLD);
  #pragma omp parallel num_threads(NUM_CPU)
  { 
    int CHUNK_SIZE = N/(NUM_CPU*DIV);
    int i, rstart, rend, t_id;
    CHUNK_SIZE++;

    t_id = omp_get_thread_num();
    
    rstart = t_id * CHUNK_SIZE;
    rend = rstart + CHUNK_SIZE-1;
    
    for(i = M/np*nodo; i < M/np*(nodo+1); i++)
    {
      accumulatelocal(a2,N,value[i],r1[i],c1[i],r2[i],c2[i], rstart, rend, CHUNK_SIZE);
    }
  }

  MPI_Reduce(a2, a, N*N, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
}
